//!!!!! po zmnienie kierunku niedzial nawet jak wrocic do poprzedniej pozycji (pewnie zwiazane z EN)
//      kanal 3 wogole nie dziala


#define	SPZMDIR		7			// minimalna prdko przy krrej mozna zmieni kierunek i aktywaya EN
#define	SPENON		5			// prdkoc przy ktrej po awarii Enable jest ponownie aktywowane
#define	IMAXTINE	5			// Max czas trwania przecienia w 10ms


#define	USREDNIANIE				// brak definicji wycza usrednianie
#define WAGA 0.8				// waga usredniania
			// Urez = I * R		Prez = U * I
			// 1A = 220mV		110mW		(L6201)
			// 1,5A=220mV		330mW		(L6202)
			// 2A = 440mV		880mW
			// 3A = 660mV		1,9W
			// 4A = 880mV		3,5W		(L6203/L6201PS)
			// 5A = 1,1V		5,5W
			//
			// U = 2,56 / 1024 * ADC
			// ADC = 1024 * Urez / 2,56
			// ADC = 1024 * 0,2V / 2,56 = 80	(1A)
			// ADC = 1024 * 0,33V/ 2,56 = 132	(1,5A)
			// ADC = 1024 * 0,5V / 2,56 = 200	(2A)
			// ADC = 1024 * 1V   / 2,56 = 400	(5A)
			//
#define		IMAX	1.5			// Dopuszczalny prd maksymalny driwera
#define		IPEAK	IMAX * 2	// Dopuszczalny prd w impulsie
			//
			//
			//ADC = rodzielczo * Prd * rezystancja / Vref
#define		ADCMAX	1024 * ( IMAX * 0.22 ) / 2.56
#define		ADCPEAK	1024 * ( IPEAK * 0.22 ) / 2.56


/********************************************************************************/
/*																				*/
/********************************************************************************/
#define	uchar	unsigned char
#define	byte	unsigned char
#define	uint	unsigned int
#define	word	unsigned int
#define	ulong	unsigned long
#define	dword	unsigned long
#define	FALSE	0
#define	TRUE	1
#define	false	FALSE
#define	true	TRUE
#define	False	FALSE
#define	True	TRUE


#define	NONE		-1
#define	PARITYERR	-2
#define	FRAMEERR	-3
#define	OVERRUNERR	-4

#define	CRLF	"\r\n"
#define	CR		'\r'
#define	LF		'\n'
#define	ESC		0x2B
#define	EXIT	ESC


#define	CNT0_PRESCALER_0		0
#define	CNT0_PRESCALER_1		1
#define	CNT0_PRESCALER_8		2
#define	CNT0_PRESCALER_64		3
#define	CNT0_PRESCALER_256		4
#define	CNT0_PRESCALER_1024		5
#define	CNT0_PRESCALER_T0faling	6
#define	CNT0_PRESCALER_T0rising	7

#define	CNT1_PRESCALER_0		0
#define	CNT1_PRESCALER_1		1
#define	CNT1_PRESCALER_8		2
#define	CNT1_PRESCALER_64		3
#define	CNT1_PRESCALER_256		4
#define	CNT1_PRESCALER_1024		5
#define	CNT1_PRESCALER_T1faling	6
#define	CNT1_PRESCALER_T1rising	7

#define	CNT2_PRESCALER_0		0
#define	CNT2_PRESCALER_1		1
#define	CNT2_PRESCALER_8		2
#define	CNT2_PRESCALER_32		3
#define	CNT2_PRESCALER_64		4
#define	CNT2_PRESCALER_128		5
#define	CNT2_PRESCALER_256		6
#define	CNT2_PRESCALER_1024		7



#include <avr/io.h>									// IO
#include <stdio.h>									//
#include <stdlib.h>									//
#include <avr/sfr_defs.h>							// SFR, _BV(bit)
#include <avr/pgmspace.h>							// Flash
#define  CODE PROGMEM
#include <avr/interrupt.h>							// wektory IRQ
#include <avr/wdt.h> 								// WDG
#include <avr/eeprom.h>								// Eeprom
#include <string.h>									// Stringi
#include <compat/deprecated.h>						// sbi, cbi, inb, outb, outp
#define  ebi(port,bit) ( port ^= (1 << (bit)))		// Negowanie bitu na porcie
#define	BAUD	250000
#include <util/setbaud.h>							// Uart 0
//#define	BAUD1	9600
//#include "include/setbaud1.h"						// Uart 1
#include <util/delay.h>
#include <util/crc16.h>								// Crc16, Xmodem, Dallas
#include <avr/fuse.h>
#define NOINIT __attribute__ ((section(".noinit")))
#define nop()	__asm__ __volatile__( "nop" )		// Wstawia rozkaz NOP do kodu
#include <avr/sleep.h>								// Tryby upienia
#include <avr/power.h>								// Wyaczanie peryferii



//---------------------------------------------------------------------------------------
/*
// Interrupt Vectors
// Interrupt Vector 0 is the reset vector.
#define INT0_vect         _VECTOR(1)   // External Interrupt Request 0
#define INT1_vect         _VECTOR(2)   // External Interrupt Request 1
#define PCINT0_vect       _VECTOR(3)   // Pin Change Interrupt Request 0
#define PCINT1_vect       _VECTOR(4)   // Pin Change Interrupt Request 0
#define PCINT2_vect       _VECTOR(5)   // Pin Change Interrupt Request 1
#define WDT_vect          _VECTOR(6)   // Watchdog Time-out Interrupt
#define TIMER2_COMPA_vect _VECTOR(7)   // Timer/Counter2 Compare Match A
#define TIMER2_COMPB_vect _VECTOR(8)   // Timer/Counter2 Compare Match A
#define TIMER2_OVF_vect   _VECTOR(9)   // Timer/Counter2 Overflow
#define TIMER1_CAPT_vect  _VECTOR(10)  // Timer/Counter1 Capture Event
#define TIMER1_COMPA_vect _VECTOR(11)  // Timer/Counter1 Compare Match A
#define TIMER1_COMPB_vect _VECTOR(12)  // Timer/Counter1 Compare Match B
#define TIMER1_OVF_vect   _VECTOR(13)  // Timer/Counter1 Overflow
#define TIMER0_COMPA_vect _VECTOR(14)  // TimerCounter0 Compare Match A
#define TIMER0_COMPB_vect _VECTOR(15)  // TimerCounter0 Compare Match B
#define TIMER0_OVF_vect   _VECTOR(16)  // Timer/Couner0 Overflow
#define SPI_STC_vect      _VECTOR(17)  // SPI Serial Transfer Complete
#define USART_RX_vect     _VECTOR(18)  // USART Rx Complete
#define USART_UDRE_vect   _VECTOR(19)  // USART, Data Register Empty
#define USART_TX_vect     _VECTOR(20)  // USART Tx Complete
#define ADC_vect          _VECTOR(21)  // ADC Conversion Complete
#define EE_READY_vect     _VECTOR(22)  // EEPROM Ready
#define ANALOG_COMP_vect  _VECTOR(23)  // Analog Comparator
#define TWI_vect          _VECTOR(24)  // Two-wire Serial Interface
#define SPM_READY_vect    _VECTOR(25)  // Store Program Memory Read

void* tim_handler;
ISR(TIMER2_COMP_vect,ISR_NAKED)
{
asm("ijmp"::"z"(tim_handler));
}

Skoro "program gwny" nic nie robi to przerwanie nigdy nie moe zepsu jego stanu, a wic nie ma powodu eby obsuga przerwan zapisywaa rejestry czy cokolwiek - dlatego ISR_NAKED.


*/



//---------------------------------------------------------------------------------------
#define	OVERTIME_DMX	1 * 100		// Liczba sekund do trybu ofline w 10ms
word volatile TimerDmx0, TimerDmx1, TimerLcd;
byte volatile TimerPwm[3] = {5,5,5};
void InitTimer0();
void InitTimer2();
void InitTimer1();

void InitInt0();
void InitInt1();


#define	PxLedDmx		PG1
#define	LedDmxDdr()		DDRG  |=  (1<<PxLedDmx)
#define	LedDmxOn()		PORTG &= ~(1<<PxLedDmx)
#define	LedDmxOff()		PORTG |=  (1<<PxLedDmx)
#define	LedDmxEor()		PORTG ^=  (1<<PxLedDmx)

#define	PxLedST			PG0
#define	LedStDdr()		DDRG  |=  (1<<PxLedST)
#define	LedStOn()		PORTG &= ~(1<<PxLedST)		// Pozim niski na wyjcu
#define	LedStOff()		DDRG  |=  (1<<PxLedST)		// Wyjcie w stanie trzecim lub wysokim
#define	LedStEor()		PORTG ^=  (1<<PxLedST)

#define	PxLedErr		PG4
#define	LedErrDdr()		DDRG  |=  (1<<PxLedErr)
#define	LedErrOn()		PORTG &= ~(1<<PxLedErr)
#define	LedErrOff()		PORTG |=  (1<<PxLedErr)
#define	LedErrEor()		PORTG ^=  (1<<PxLedErr)

#define	PxLedCh1on			PB0
#define	LedLedCh1onDdr()	DDRB  |=  (1<<PxLedCh1on)
#define	LedLedCh1onOn()		PORTB &= ~(1<<PxLedCh1on)
#define	LedLedCh1onOff()	PORTB |=  (1<<PxLedCh1on)
#define	LedLedCh1onEor()	PORTB ^=  (1<<PxLedCh1on)

#define	PxLedCh2on			PD2
#define	LedLedCh2onDdr()	DDRD  |=  (1<<PxLedCh2on)
#define	LedLedCh2onOn()		PORTD &= ~(1<<PxLedCh2on)
#define	LedLedCh2onOff()	PORTD |=  (1<<PxLedCh2on)
#define	LedLedCh2onEor()	PORTD ^=  (1<<PxLedCh2on)

#define	PxLedCh3on			PB3
#define	LedLedCh3onDdr()	DDRB  |=  (1<<PxLedCh3on)
#define	LedLedCh3onOn()		PORTB &= ~(1<<PxLedCh3on)
#define	LedLedCh3onOff()	PORTB |=  (1<<PxLedCh3on)
#define	LedLedCh3onEor()	PORTB ^=  (1<<PxLedCh3on)

#define	PxLedCh1err			PB2
#define	LedLedCh1errDdr()	DDRB  |=  (1<<PxLedCh1err)
#define	LedLedCh1errOn()	PORTB &= ~(1<<PxLedCh1err)
#define	LedLedCh1errOff()	PORTB |=  (1<<PxLedCh1err)
#define	LedLedCh1errEor()	PORTB ^=  (1<<PxLedCh1err)

#define	PxLedCh2err			PD1
#define	LedLedCh2errDdr()	DDRD  |=  (1<<PxLedCh2err)
#define	LedLedCh2errOn()	PORTD &= ~(1<<PxLedCh2err)
#define	LedLedCh2errOff()	PORTD |=  (1<<PxLedCh2err)
#define	LedLedCh2errEor()	PORTD ^=  (1<<PxLedCh2err)

#define	PxLedCh3err			PB1
#define	LedLedCh3errDdr()	DDRB  |=  (1<<PxLedCh3err)
#define	LedLedCh3errOn()	PORTB &= ~(1<<PxLedCh3err)
#define	LedLedCh3errOff()	PORTB |=  (1<<PxLedCh3err)
#define	LedLedCh3errEor()	PORTB ^=  (1<<PxLedCh3err)


#define	MIN_DMX_OFLINE	1			// Czas braku transmisji w sekundach, uznany jako brak sygnalu DMX
enum{DMX_OFFLINE, DMX_BREAK};


#define	LENBUFDMX	513
void InitUart0();
byte TxBuf0[ LENBUFDMX ];
byte DmxStatus0 = DMX_OFFLINE;
word volatile LenDmx0, PtrTxRs;
byte volatile TxEmpty = TRUE;
#define	LENTABDATA	6
byte volatile TabPwm[ LENTABDATA ];
byte volatile ErrI=0;


#define	DdrTx()			DDRG  |=  (1<<PG0);			// Port wyjsciem
#define	ClrTx()			PORTG &= ~(1<<PG0);			// wygeneruj BREAK
#define	SetTx()			PORTG |=  (1<<PG0);			// wygeneruj MAB
void SendDmx( word len );
word LenTxRs;

void InitUart1();

void InitAdc();
word TabAdc[4];


#define	DdrPWM1()		DDRE  |=  (1<<PE3)
#define	DdrPWM2()		DDRE  |=  (1<<PE4)
#define	DdrPWM3()		DDRE  |=  (1<<PE5)

#define	DdrEN1()		DDRC  |=  (1<<PC4)
#define	OnEN1()			PORTC |=  (1<<PC4)
#define	OffEN1()		PORTC &= ~(1<<PC4)
#define	RdEN1()			(PINC &   (1<<PC4))

#define	DdrEN2()		DDRC  |=  (1<<PC5)
#define	OnEN2()			PORTC |=  (1<<PC5)
#define	OffEN2()		PORTC &= ~(1<<PC5)
#define	RdEN2()			(PINC &   (1<<PC5))

#define	DdrEN3()		DDRC  |=  (1<<PC6)
#define	OnEN3()			PORTC |=  (1<<PC6)
#define	OffEN3()		PORTC &= ~(1<<PC6)
#define	RdEN3()			(PINC &   (1<<PC6))

#define	DdrDIR1()		DDRD   |=  (1<<PD4)
#define	SetDIR1()		PORTD  |=  (1<<PD4)
#define	ClrDIR1()		PORTD  &= ~(1<<PD4)

#define	DdrDIR2()		DDRD   |=  (1<<PD5)
#define	SetDIR2()		PORTD  |=  (1<<PD5)
#define	ClrDIR2()		PORTD  &= ~(1<<PD5)

#define	DdrDIR3()		DDRD   |=  (1<<PD6)
#define	SetDIR3()		PORTD  |=  (1<<PD6)
#define	ClrDIR3()		PORTD  &= ~(1<<PD6)

#define	SetSENSE1		0
#define	SetSENSE2		1
#define	SetSENSE3		2
#define	SetPotPWM		3

void InitTimer3();
void PwmInit(byte frequency);
void SetSpeed(byte pwm, byte speed, byte dir);



word ReadAdrDMX();
word AdrDMX=0;

#define	DdrA0()		PORTA |=(1<<PA0)			// Wlacz podciaganie
#define	RdA0()		(PINA & (1<<PA0))
#define	DdrA1()		PORTA |=(1<<PA1)
#define	RdA1()		(PINA & (1<<PA1))
#define	DdrA2()		PORTA |=(1<<PA2)
#define	RdA2()		(PINA & (1<<PA2))
#define	DdrA3()		PORTA |=(1<<PA3)
#define	RdA3()		(PINA & (1<<PA3))
#define	DdrA4()		PORTA |=(1<<PA4)
#define	RdA4()		(PINA & (1<<PA4))
#define	DdrA5()		PORTA |=(1<<PA5)
#define	RdA5()		(PINA & (1<<PA5))
#define	DdrA6()		PORTA |=(1<<PA6)
#define	RdA6()		(PINA & (1<<PA6))
#define	DdrA7()		PORTA |=(1<<PA7)
#define	RdA7()		(PINA & (1<<PA7))
#define	DdrA8()		PORTC |=(1<<PC3)
#define	RdA8()		(PINC & (1<<PC3))


//----- Zworka zalozona to pojedyncza transmisja jest akceptowana, brak zworki: to dwie identyczne transmisje zmienia stan wyjscia
#define	DdrCfg0()	PORTC |=(1<<PC2)			// Wlacz podciaganie
#define	RdCfg0()	(PINC & (1<<PC2))

//----- Zworka zalozona to przy braku transmiji wyjscia wylaczane, brak zworki: wyjscie pamieta ostatni stan
#define	DdrCfg1()	PORTC |=(1<<PC1)			// Wlacz podciaganie
#define	RdCfg1()	(PINC & (1<<PC1))

#define	DdrCfg2()	PORTC |=(1<<PC0)			// Wlacz podciaganie
#define	RdCfg2()	(PINC & (1<<PC0))			// NIE UZYWANE


//**********************************************************************//
//						Bity konfiguracyjne		 						//
//**********************************************************************//
__fuse_t __fuse __attribute__((section (".fuse"))) =
#if defined(__AVR_ATmega128__)
{
	.extended	= 0xFE,
	.high		= 0x99,
	.low		= 0x7F,
};
#else
	#error "NIEZNANY TYP PROCESORA w ustawieniu bitow konfiguracyjnych"
#endif

/*
__attribute__((section (".lock"))) const unsigned char __lock =
0xFC;
*/



//**********************************************************************//
//						Program glowny			 						//
//**********************************************************************//
int main()
{
	nop();

	InitTimer0();
//	InitTimer1();
//	InitTimer2();
	InitTimer3();

	InitUart0();
//	InitUart1();

//	InitInt0();
//	InitInt1();

	InitAdc();

	//--- init WDG ---//
	//WDTO_15MS
	//WDTO_30MS
	//WDTO_60MS
	//WDTO_120MS
	//WDTO_250MS
	//WDTO_500MS
	//WDTO_1S
	//WDTO_2S
	wdt_enable( WDTO_500MS );									// Blokuje IRQ !!!


	LedDmxDdr(); LedStDdr(); LedErrDdr();
	LedDmxOff(); LedStOff(); LedErrOff();

	LedLedCh1onDdr(); LedLedCh2onDdr(); LedLedCh3onDdr();
	LedLedCh1onOff(); LedLedCh2onOff(); LedLedCh3onOff();

	LedLedCh1errDdr(); LedLedCh2errDdr(); LedLedCh3errDdr();
	LedLedCh1errOff(); LedLedCh2errOff(); LedLedCh3errOff();


	DdrPWM1(); DdrPWM2(); DdrPWM3(); DdrEN1(); DdrEN2(); DdrEN3(); DdrDIR1(); DdrDIR2(); DdrDIR3();
	PwmInit( 4 );
	OffEN1(); OffEN2(); OffEN3();


	DdrA0(); DdrA1(); DdrA2(); DdrA3(); DdrA4(); DdrA5(); DdrA6(); DdrA7(); DdrA8();
	DdrCfg0(); DdrCfg1(); DdrCfg2();
	AdrDMX = ReadAdrDMX();							// odczytaj adres DMX z DIP-switch


	sei();


	SendDmx( 24 );		// Init nadawania


	//-----------------------------------------------------------------------------------
	//								Petla glowna
	//-----------------------------------------------------------------------------------
	while( 1 )
		{
		wdt_reset();

		AdrDMX = ReadAdrDMX();							// odczytaj adres DMX z DIP-switch


		SetSpeed( 0, TabPwm[ 0 ], TabPwm[ 1 ] );
		SetSpeed( 1, TabPwm[ 2 ], TabPwm[ 3 ] );
		SetSpeed( 2, TabPwm[ 4 ], TabPwm[ 5 ] );


		if ( DmxStatus0 == DMX_OFFLINE )		// Obsluga diody led
			{
			LedDmxOff();
			LedStOn();
			}
		else
			{
			LedDmxOn();
			}

		}
}



//**********************************************************************//



//-------------------------------------------------------------------------
//					Init timer 0
//-------------------------------------------------------------------------
void InitTimer0()
{
	TCCR0 = 7;							// podzielnik 1024
	TIMSK |= (1<<TOIE0);				// Zezwolenie na IRQ od przepelnienia timera
}


//----------------------------------------------------------------------//
//					Obsuga IRQ od timera 0 - czasy MAB
//----------------------------------------------------------------------//
INTERRUPT( TIMER0_OVF_vect )			// Mozliwe przerwanie wielopoziomowe (pierwsza instrukcja SEI)
{


	TCNT0 = 256 - 157;					// Przerwania co okoo 10ms


	if ( TimerDmx0 ) TimerDmx0--;
	if ( TimerDmx1 ) TimerDmx1--;

	if ( TimerDmx0 == 1) { DmxStatus0 = DMX_OFFLINE; LenDmx0 = 0; }
//	if ( TimerDmx1 == 1) { DmxStatus1 = DMX_OFFLINE; LenDmx1 = 0; }


	if ( TimerPwm[0] ) TimerPwm[0]--;
	if ( TimerPwm[1] ) TimerPwm[1]--;
	if ( TimerPwm[2] ) TimerPwm[2]--;
}


//-------------------------------------------------------------------------
//					Init timer 1
//-------------------------------------------------------------------------
void InitTimer1()
{
	TCCR1B = ( CNT1_PRESCALER_64 );		// Preskaler na 256
										// F = 8000000/64 = 125kHz
										// t = 4us
	TCNT1 = 0xFFFF - 2;
//	TIMSK1 |= (1<<TOIE1);				// Zezwolenie na IRQ od przepelnienia timera
}



//----------------------------------------------------------------------//
//					Obsuga IRQ od timera 1
//----------------------------------------------------------------------//
//SIGNAL( TIMER1_OVF_vect )				// NIE MOZLIWE przerwanie wielopoziomowe (brak instrukcji SEI)
INTERRUPT( TIMER1_OVF_vect )			// MOZLIWE przerwanie wielopoziomowe (brak instrukcji SEI)
{


}


//----------------------------------------------------------------------//
//					Obsuga IRQ od porownania comparatora A				//
//----------------------------------------------------------------------//
INTERRUPT( TIMER1_COMPA_vect )			// MOZLIWE przerwanie wielopoziomowe (brak instrukcji SEI)
{

}


//----------------------------------------------------------------------//
//					Obsuga IRQ od porownania comparatora B				//
//----------------------------------------------------------------------//
INTERRUPT( TIMER1_COMPB_vect )			// MOZLIWE przerwanie wielopoziomowe (brak instrukcji SEI)
{

}


//-------------------------------------------------------------------------
//					Init timer 2
//-------------------------------------------------------------------------
void InitTimer2()
{
//	TCCR2B = CNT0_PRESCALER_8;				// Preskaler na 8 (liczymy us)
}


//----------------------------------------------------------------------//
//					Obsuga IRQ od timera 2
//----------------------------------------------------------------------//
INTERRUPT( TIMER2_OVF_vect )			// Mozliwe przerwanie wielopoziomowe (pierwsza instrukcja SEI)
{
//	TCNT2_HH += 0x100;					// Zwiekszamy o 256
}


//--------------------------------------------------------------------------
//					Inicjalizacja INT 0
//--------------------------------------------------------------------------
void InitInt0()
{
	EIMSK  |= (1<<INT0);				// INT0   - Zezwolenie na IRQ od wejscia INT0
//	EICRA  |= (1<<ISC00);				// INT0   - Kazde zbocze na INT0 wywouje IRQ
	EICRA  |= (2<<ISC00);				// INT0   - Zbocze narastajace na INT0 wywouje IRQ

	PORTD |= (1<<PIND0) | (1<<PIND1);	// Wejcia A i B z podciganiem
}


//----------------------------------------------------------------------//
//					Obsuga IRQ od wejcia INT 0						//
//----------------------------------------------------------------------//
SIGNAL( INT0_vect )						// NIE MOZLIWE przerwanie wielopoziomowe (brak instrukcji SEI)
//INTERRUPT( INT0_vect )					// Mozliwe przerwanie wielopoziomowe (pierwsza instrukcja SEI)
{
//	EIMSK  &= ~(1<<INT0);				// INT0   - Zablokuj IRQ od wejscia INT0


//	EIMSK  |= (1<<INT0);				// INT0   - Zezwolenie na IRQ od wejscia INT0
}



//--------------------------------------------------------------------------
//					Inicjalizacja INT 1
//--------------------------------------------------------------------------
void InitInt1()
{
	EIMSK  |= (1<<INT1);				// INT1   - Zezwolenie na IRQ od wejscia INT1
	EICRA  |= (1<<ISC10);				// INT1   - Kazde zbocze na INT1 wywouje IRQ
//	EICRA  |= (2<<ISC10);				// INT1   - Zbocze narastajace na INT1 wywouje IRQ

	PORTD |= (1<<PIND0) | (1<<PIND1);	// Wejcia A i B z podciganiem
}


//----------------------------------------------------------------------//
//					Obsuga IRQ od wejcia INT 1						//
//----------------------------------------------------------------------//
//SIGNAL( INT1_vect )					// NIE MOZLIWE przerwanie wielopoziomowe (brak instrukcji SEI)
INTERRUPT( INT1_vect )					// Mozliwe przerwanie wielopoziomowe (pierwsza instrukcja SEI)
{

}


//------------------------------------------------------------------------------
//					Inicjalizacja USART-a
//------------------------------------------------------------------------------
void InitUart0()
{
#if F_CPU == 16000000
	UBRR0H = 0;
	UBRR0L = 3;			// Dla 16MHz
	UCSR0A = 0;
#elif F_CPU == 8000000
	UBRR0H = 0;			// Dla 8MHz
	UBRR0L = 1;			// Tablica 19-11 str 196
	UCSR0A = 0;
//	UBRR0L = 3;			// Tablica 19-11 str 196
//	UCSR0A = (1<<U2X0);
#else
 #error "Nieznane FCLK"
#endif
	UCSR0B = (1<<RXEN0) | (1<<TXEN0) | (1<<RXCIE0) | (1<<TXCIE0);
	UCSR0C = (1<<USBS0) | (3<<UCSZ00);								// Set frame format: 8data, 2stop bit
}


//----------------------------------------------------------------------//
//					Obsluga IRQ od odbiornika USART-a
//------------------------------------------------------------------------------
//#define USART_RX_vect     _VECTOR(18)  /* USART Rx Complete */
//#define USART_UDRE_vect   _VECTOR(19)  /* USART, Data Register Empty */
//
//INTERRUPT( USART_RX_vect )		// Mozliwe przerwanie wielopoziomowe
SIGNAL( USART0_RX_vect )			// Nie mozliwe przerwanie wielopoziomowe
{
byte UsartStatus, UsartDana;
byte static lastDana[ LENTABDATA ];
word static CntDanych=0;
byte x, temp;
static byte tdmx[513];


	UsartStatus = UCSR0A;
	UsartDana = UDR0;
	UCSR0A = 0;


	if ( (UsartStatus & (1<<FE0)) )				// Jesli wykryto blad ramki to skonczyl sie sygnal BREAK
		{
		DmxStatus0 = DMX_BREAK;					// Ustaw status
		CntDanych = 0;							// Zeruj licznik danych
		if ( ! tdmx[ 0 ] )						// Jeli CS rwny zero
			{
			for(x=0; x<LENTABDATA; x++)			// Przepisanie danych z tablicy DMX do tablicy PWM
				{
				temp = tdmx[ x + AdrDMX + 1 ];	// Zapamitujemy dan
				if ( ! RdCfg0() )				// Jeli zwora zaaoona
					{
					TabPwm[ x ] = temp;			// Zapamietaj wynik w tablicy PWM
					}
				else							// Brak zwory
					{
					if ( lastDana[ x ] == temp )// Jeli poprzednia dana taka sama jak odczytana teraz
						{
						TabPwm[ x ] = temp;		// Zapamietaj wynik w tablicy PWM
						}
					lastDana[ x ] = temp;		// Zapamitaj do nastpnego porwnania
					}
				}
			}
		return;
		}
	else if(DmxStatus0 == DMX_BREAK)			// Jesli byl BREAK i pojawila sie nowa dana:
		{
		LedStEor();
		if ( CntDanych>513 ) { DmxStatus0=DMX_OFFLINE; return; }// Jesli za duzo danych
		}


	tdmx[CntDanych]=UsartDana;
	CntDanych++;
}


//----------------------------------------------------------------------//
void SendDmx( word len )
{
	LenTxRs = len;
	if ( LenTxRs > LENBUFDMX ) LenTxRs = LENBUFDMX;
	TxEmpty = FALSE;

	// Program gwny generuje BREAK i MAB po czym wyle dane (wpis do UDR0)
	DdrTx();							// Port wyjsciem
	UCSR0B &= ~(1<<TXEN0);				// wycz TX UARTA
	ClrTx(); _delay_us(200);			// wygeneruj BREAK
	SetTx(); _delay_us(88);				// wygeneruj MAB
	UCSR0B |= (1<<TXEN0);				// wcz TX UARTA
	UDR0 = TxBuf0[ PtrTxRs=0 ];			// Wpisz do nadajnika pierwszy znak (start transmisji)
}


//----------------------------------------------------------------------//
//				Przerwanie nadawcze od uarta
//----------------------------------------------------------------------//
#define USART_UDRE_vect   _VECTOR(19)  /* USART, Data Register Empty */
#define USART_TX_vect     _VECTOR(20)  /* USART Tx Complete */
//----------------------------------------------------------------------//
SIGNAL(USART0_TX_vect)		// Musi byc ISR lub SIGNAL a nie INTERUPT
{
	PtrTxRs++;							// Wskanik na nastpny znak
	if ( PtrTxRs < LenTxRs )			// Jeli s jeszcze znaki do wysania
		{
		UDR0 = TxBuf0[ PtrTxRs ];		// Wpisz do nadajnika
		}
	else
		{
		TxEmpty = TRUE;					// Wszystkie znaki wysane (ostatnie IRQ)
		}
}


//------------------------------------------------------------------------------
//					Inicjalizacja USART-a
//------------------------------------------------------------------------------
void InitUart1()
{
#if F_CPU == 16000000
	UBRR1H = 0;
	UBRR1L = 3;			// Dla 16MHz
	UCSR1A = 0;
#elif F_CPU == 8000000
	UBRR1H = 0;			// Dla 8MHz
	UBRR1L = 1;			// Tablica 19-11 str 196
	UCSR1A = 0;
//	UBRR1L = 3;			// Tablica 19-11 str 196
//	UCSR1A = (1<<U2X0);
#else
 #error "Nieznane F_CPU"
#endif
	UCSR1B = (1<<RXEN1) | (1<<RXCIE1);
	UCSR1C = (1<<USBS1) | (3<<UCSZ10);								// Set frame format: 8data, 2stop bit
}


//----------------------------------------------------------------------//
//					Obsluga IRQ od odbiornika USART-a
//------------------------------------------------------------------------------
//#define USART_RX_vect     _VECTOR(18)  /* USART Rx Complete */
//#define USART_UDRE_vect   _VECTOR(19)  /* USART, Data Register Empty */
//
//INTERRUPT( USART_RX_vect )		// Mozliwe przerwanie wielopoziomowe
SIGNAL( USART1_RX_vect )			// Nie mozliwe przerwanie wielopoziomowe
{
byte UsartStatus, UsartDana;


	UsartStatus = UCSR1A;
	UsartDana = UDR1;
	UCSR1A = 0;


}


//**********************************************************************//
void InitTimer3()
{
	ETIMSK |= (1<<TOIE3);
}


//----------------------------------------------------------------------//
//					Obsuga IRQ od timera 3
//----------------------------------------------------------------------//
//SIGNAL( TIMER3_OVF_vect )				// NIE MOZLIWE przerwanie wielopoziomowe (brak instrukcji SEI)
INTERRUPT( TIMER3_OVF_vect )			// MOZLIWE przerwanie wielopoziomowe (brak instrukcji SEI)
{
byte static CntAdc=0;
float static Srednia[LENTABDATA] = { 0, 0, 0, 0 };
word temp=0;


	if ( !(ADCSRA & ADIF) ) return;		// Jak nie przetworzy to wyjd


#ifndef	USREDNIANIE
	TabAdc[ CntAdc ] = ADC;
#else
//	Srednia[ CntAdc ] = Srednia[ CntAdc ] * WAGA + (1-WAGA) * temp;
	Srednia[ CntAdc ] = Srednia[ CntAdc ] * WAGA + (1-WAGA) * ADC;
	TabAdc[ CntAdc ] = Srednia[ CntAdc ];
#endif


	if ( CntAdc < 4 )
		{
		if ( ( (ADC <= ADCPEAK) && (TabPwm[CntAdc] <  50 ) )	||	// Jeli prd w normie (IPEK nieprekroczone dla PWM < 50
			 ( (ADC <= ADCMAX)  && (TabPwm[CntAdc] >= 50 ) ) )		// lub IMAX nieprekroczone dla PWM >= 50
			{
			TimerPwm[CntAdc] = IMAXTINE;	// Ustaw timeout
			if ( !ErrI )
				{
				LedErrOff();				// Jak wszystkie wyjcia nie przecione wycz lampke
				}
			}
		else								// Prad za duy
			{
			if ( ! TimerPwm[CntAdc] )		// i min timeout
				{
				LedErrOn();					// wlaczyc lampke error
				switch( CntAdc )			// wylaczyc en
					{
					case 0:
						OffEN1(); LedLedCh1errOn(); ErrI |= 1; 
						break;
					case 1:
						OffEN2(); LedLedCh2errOn(); ErrI |= 2; 
						break;
					case 2:
						OffEN3(); LedLedCh3errOn(); ErrI |= 4;
						break;
					}
nop();
				}
			}
		}

	CntAdc++; CntAdc &= 3;
	ADMUX &= ~(0x1F); ADMUX |= CntAdc;	// Przeczenie muxa
	ADCSRA |= ADIF;						// Wyczyszczenie znacznika
	ADCSRA |= (1<<ADSC);				// Start konwersji
}


//----------------------------------------------------------------------//
void InitAdc()
{
	ADMUX = (3<<REFS0);					// Wewnetrzne napicie 2,56V
	ADCSRA = (1<<ADEN) | (7<<ADPS0);
	ADCSRA |= (1<<ADSC);				// Start konwersji

}


//----------------------------------------------------------------------//
void PwmInit(byte frequency)
{

// frequency zakres 1...5 albo 6 czy 7 (taktowanie zewnetrzne) i na wejscie T1 dac wyjscie innego timera o czestotliwosci regulowanej potencjometrem


	TCCR1A |= (1<<WGM10) | (2<<COM1A0) | (2<<COM1B0) | (2<<COM1C0);
	TCCR1B |= (1<<WGM12) | (frequency & 7);
	TCCR3C |= (1<<FOC1A) | (1<<FOC1B) | (1<<FOC1C);

	TCCR3A |= (1<<WGM30) | (2<<COM3A0) | (2<<COM3B0) | (2<<COM3C0);
	TCCR3B |= (1<<WGM32) | (frequency & 7);
	TCCR3C |= (1<<FOC3A) | (1<<FOC3B) | (1<<FOC3C);
}


//----------------------------------------------------------------------//
void SetSpeed(byte pwm, byte speed, byte dir)
{
//static byte memSpeed0a, memDir0a;
//static byte memSpeed0b, memDir0b;
//static byte memSpeed0c, memDir0c;
static byte memSpeed3A=5, memDir3A=5;
static byte memSpeed3B=5, memDir3B=5;
static byte memSpeed3C=5, memDir3C=5;


	switch( pwm )
		{
		//-----------------------------
		case 0:
			if ( memSpeed3A != speed  )
				{
				memSpeed3A = speed;
				OCR3A = speed;
				if ( !speed ) 							// Przy prdkoci 0 wycz driwer
					{
					OffEN1(); LedLedCh1onOff();
					}
				else if ( (speed < SPENON) && (ErrI & 1) )// Po awarii Enable aktywne przy predkosci mniejszej niz SPENON
					{
					OnEN1(); LedLedCh1onOn();			// wlaczyc en gdy DMX = 0
					ErrI &= ~1;	LedLedCh1errOff();		// kasuj bd
					}
				else if ( (speed > SPZMDIR) && ( !(ErrI & 1)) ) 
					{
					OnEN1(); LedLedCh1onOn();			// wlaczyc en gdy DMX = 0					
					}
				}
			//- - - - - - - - - - - - -
			if ( speed < SPZMDIR )						// Zmniana kierunku moliwa gdy silnik stoi
				{										// lub obraca sie wolno
				if ( memDir3A != dir )
					{
					memDir3A = dir;
					TCCR3A &= ~(3<<COM3A0);				// Skasowanie bitw COM3A
					if ( dir < 0x80-20 )
						{
						TCCR3A |= (2<<COM3A0);ClrDIR1();// Kierunek naprzd
						}
					else if ( dir > 0x80+20 )
						{
						TCCR3A |= (3<<COM3A0);SetDIR1();// Kierunek wstecz
						}
					}
				}
			break;
		//-----------------------------
		case 1:
			if ( memSpeed3B != speed  )
				{
				memSpeed3B = speed;
				OCR3B = speed;
				if ( !speed ) 							// Przy prdkoci 0 wycz driwer
					{
					OffEN2(); LedLedCh2onOff();
					}
				else if ( (speed < SPENON) && (ErrI & 2) )// Po awarii Enable aktywne przy predkosci mniejszej niz SPENON
					{
					OnEN2(); LedLedCh2onOn();			// wlaczyc en gdy DMX = 0
					ErrI &= ~2;	LedLedCh2errOff();		// kasuj bd
					}
				else if ( (speed > SPZMDIR) && ( !(ErrI & 2)) ) 
					{
					OnEN2(); LedLedCh2onOn();			// wlaczyc en gdy DMX = 0					
					}
				}
			//- - - - - - - - - - - - -
			if ( speed < SPZMDIR )						// Zmniana kierunku moliwa gdy silnik stoi
				{										// lub obraca sie wolno
				if ( memDir3B != dir )
					{
					memDir3B = dir;
					TCCR3A &= ~(3<<COM3B0);				// Skasowanie bitw COM3B
					if ( dir < 0x80-20 )
						{
						TCCR3A |= (2<<COM3B0);ClrDIR2();// Kierunek naprzd
						}
					else if ( dir > 0x80+20 )
						{
						TCCR3A |= (3<<COM3B0);SetDIR2();// Kierunek wstecz
						}
					}
				}
			break;
		//-----------------------------
		case 2:
			if ( memSpeed3C != speed  )
				{
				memSpeed3C = speed;
				OCR3C = speed;
				if ( !speed ) 							// Przy prdkoci 0 wycz driwer
					{
					OffEN3(); LedLedCh3onOff();
					}
				else if ( (speed < SPENON) && (ErrI & 4) )// Po awarii Enable aktywne przy predkosci mniejszej niz SPENON
					{
					OnEN3(); LedLedCh3onOn();			// wlaczyc en gdy DMX = 0
					ErrI &= ~4; LedLedCh3errOff();		// kasuj bd
					}
				else if ( (speed > SPZMDIR) && ( !(ErrI & 4)) ) 
					{
					OnEN3(); LedLedCh3onOn();			// wlaczyc en gdy DMX = 0					
					}
				}
			//- - - - - - - - - - - - -
			if ( speed < SPZMDIR )						// Zmniana kierunku moliwa gdy silnik stoi
				{										// lub obraca sie wolno
				if ( memDir3C != dir )
					{
					memDir3C = dir;
					TCCR3A &= ~(3<<COM3C0);				// Skasowanie bitw COM3C
					if ( dir < 0x80-20 )
						{
						TCCR3A |= (2<<COM3C0);ClrDIR3();// Kierunek naprzd
						}
					else if ( dir > 0x80+20 )
						{
						TCCR3A |= (3<<COM3C0);SetDIR3();// Kierunek wstecz
						}
					}
				}
			break;
		}



}


//----------------------------------------------------------------------//
void PWM2set(byte pwm, byte dir)
{
}


//----------------------------------------------------------------------//
void PWM3set(byte pwm, byte dir)
{
}



//----------------------------------------------------------------------//
word ReadAdrDMX()
{
word adr=0;


	if ( RdA0()==0 ) adr |= (1<<0);
	if ( RdA1()==0 ) adr |= (1<<1);
	if ( RdA2()==0 ) adr |= (1<<2);
	if ( RdA3()==0 ) adr |= (1<<3);
	if ( RdA4()==0 ) adr |= (1<<4);
	if ( RdA5()==0 ) adr |= (1<<5);
	if ( RdA6()==0 ) adr |= (1<<6);
	if ( RdA7()==0 ) adr |= (1<<7);
	if ( RdA8()==0 ) adr |= (1<<8);

	if (adr==0) adr=512;

	return( adr );
}


//------------------------------------------------------------------------------//



